
package polyglot.ext.polyj.util;

import polyglot.types.*;
import polyglot.ext.polyj.types.InstType;

public interface InstantiationBinding {
    public ClassType type();

    /**
     * returns true iff this instantiations needs an
     * adapter class represetnation.
     */
    public boolean needsAdapterClass();

    public String getAdapterClassPackageName();
    public String getAdapterClassShortName();
    public String getAdapterClassFullName();

    /** Given a wherebinding (for this instantiated type)
     * returns the MTI for the method that this particular
     * instantiation uses to satisfy that constraint.
     * **NB**: Until we implement renaming, this method
     *  will usually have the same name as the short name
     *  of the constraint, but once renaming is implemented,
     *  this can be more or less an arbitrary method.
     */
    public MethodInstance getImplementingMethod(WhereBinding constraint);
}
